Create Child Test Suite Entity
POST {{apiPath}}/test-suite/{{testSuiteEntityId}}?branch={{branchId}}
The POST /test-suite/{{testSuiteEntryId}} operation creates a new child test suite entity. The allowable values for {{testSuiteType}} are TEST_SCENARIO, TEST_CASE, or ASSERTION. The request must provide either a branch ID or a snapshot ID in the request URL to specify where the test suite entity should be created.
Prerequisites
-
Create a branch to get a branch ID.
-
Create a snapshot to get a snapshot ID.
Query parameters
| Query parameter | Description |
|---|---|
|
Branch ID or name |
|
Snapshot ID |
Request Model
For property descriptions, refer to Test suite data model
=== Test scenario request model
| Property | Type | Required |
|---|---|---|
|
String |
Required |
|
String |
Optional |
|
String |
Required |
|
UUID |
Optional |
|
JSON[] |
Optional |
|
Boolean |
Optional |
|
String |
Optional |
|
String |
Optional |
|
String |
Optional |
|
String |
Optional |
|
JSON |
Optional |
|
JSON |
Optional |
To create an test scenario group rather than an individual test scenario, set the testScenario property to null.
=== Test case request model
| Property | Type | Required |
|---|---|---|
|
String |
Required |
|
String |
Optional |
|
String |
Required |
|
UUID |
Optional |
|
JSON[] |
Optional |
|
Boolean |
Optional |
|
Required |
|
|
Optional |
|
|
String |
Optional |
|
String |
Optional |
|
String |
Optional |
|
String |
Optional |
|
String |
Optional |
|
JSON |
Optional |
|
JSON |
Optional |
To create an test case group rather than an individual test case, set the testCase property to null.
=== Assertion data model
| Property | Type | Required |
|---|---|---|
|
String |
Required |
|
String |
Optional |
|
UUID |
Optional |
|
String |
Optional |
|
JSON[] |
Optional |
|
Boolean |
Optional |
|
String |
Required |
|
String |
Optional |
|
String |
Required |
|
String |
Required |
To create an assertion group rather than an individual assertion, set the assertion property to null.
Body
raw ( application/json )
{
"name": "child-test-scenario",
"description": "",
"objectType": "TestScenarioDefinition",
"permissions": {
"inherit": true,
"rolePermissions": []
},
"testScenario": {
"request": {
"actionId": {{actionId}},
"serviceId": {{serviceId}}
},
"attributeOverrides": {},
"serviceOverrides": {}
}
}
Example Request
-
cURL
-
C#
-
Go
-
HTTP
-
Java
-
jQuery
-
NodeJS
-
Python
-
PHP
-
Ruby
-
Swift
curl --location --globoff '{{apiPath}}/test-suite/{{testSuiteEntityId}}?branch={{branchId}}' \
--header 'x-user-id: {{userId}}' \
--header 'Content-Type: application/json' \
--data '{
"name": "child-test-scenario",
"description": "",
"objectType": "TestScenarioDefinition",
"permissions": {
"inherit": true,
"rolePermissions": []
},
"testScenario": {
"request": {
"actionId": {{actionId}},
"serviceId": {{serviceId}}
},
"attributeOverrides": {},
"serviceOverrides": {}
}
}'
var options = new RestClientOptions("{{apiPath}}/test-suite/{{testSuiteEntityId}}?branch={{branchId}}")
{
MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Post);
request.AddHeader("x-user-id", "{{userId}}");
request.AddHeader("Content-Type", "application/json");
var body = @"{" + "\n" +
@" ""name"": ""child-test-scenario""," + "\n" +
@" ""description"": """"," + "\n" +
@" ""objectType"": ""TestScenarioDefinition""," + "\n" +
@" ""permissions"": {" + "\n" +
@" ""inherit"": true," + "\n" +
@" ""rolePermissions"": []" + "\n" +
@" }," + "\n" +
@" ""testScenario"": {" + "\n" +
@" ""request"": {" + "\n" +
@" ""actionId"": {{actionId}}," + "\n" +
@" ""serviceId"": {{serviceId}}" + "\n" +
@" }," + "\n" +
@" ""attributeOverrides"": {}," + "\n" +
@" ""serviceOverrides"": {}" + "\n" +
@" }" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "{{apiPath}}/test-suite/{{testSuiteEntityId}}?branch={{branchId}}"
method := "POST"
payload := strings.NewReader(`{
"name": "child-test-scenario",
"description": "",
"objectType": "TestScenarioDefinition",
"permissions": {
"inherit": true,
"rolePermissions": []
},
"testScenario": {
"request": {
"actionId": {{actionId}},
"serviceId": {{serviceId}}
},
"attributeOverrides": {},
"serviceOverrides": {}
}
}`)
client := &http.Client {
}
req, err := http.NewRequest(method, url, payload)
if err != nil {
fmt.Println(err)
return
}
req.Header.Add("x-user-id", "{{userId}}")
req.Header.Add("Content-Type", "application/json")
res, err := client.Do(req)
if err != nil {
fmt.Println(err)
return
}
defer res.Body.Close()
body, err := io.ReadAll(res.Body)
if err != nil {
fmt.Println(err)
return
}
fmt.Println(string(body))
}
POST /test-suite/{{testSuiteEntityId}}?branch={{branchId}} HTTP/1.1
Host: {{apiPath}}
x-user-id: {{userId}}
Content-Type: application/json
{
"name": "child-test-scenario",
"description": "",
"objectType": "TestScenarioDefinition",
"permissions": {
"inherit": true,
"rolePermissions": []
},
"testScenario": {
"request": {
"actionId": {{actionId}},
"serviceId": {{serviceId}}
},
"attributeOverrides": {},
"serviceOverrides": {}
}
}
OkHttpClient client = new OkHttpClient().newBuilder()
.build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "{\n \"name\": \"child-test-scenario\",\n \"description\": \"\",\n \"objectType\": \"TestScenarioDefinition\",\n \"permissions\": {\n \"inherit\": true,\n \"rolePermissions\": []\n },\n \"testScenario\": {\n \"request\": {\n \"actionId\": {{actionId}},\n \"serviceId\": {{serviceId}}\n },\n \"attributeOverrides\": {},\n \"serviceOverrides\": {}\n }\n}");
Request request = new Request.Builder()
.url("{{apiPath}}/test-suite/{{testSuiteEntityId}}?branch={{branchId}}")
.method("POST", body)
.addHeader("x-user-id", "{{userId}}")
.addHeader("Content-Type", "application/json")
.build();
Response response = client.newCall(request).execute();
var settings = {
"url": "{{apiPath}}/test-suite/{{testSuiteEntityId}}?branch={{branchId}}",
"method": "POST",
"timeout": 0,
"headers": {
"x-user-id": "{{userId}}",
"Content-Type": "application/json"
},
"data": "{\n \"name\": \"child-test-scenario\",\n \"description\": \"\",\n \"objectType\": \"TestScenarioDefinition\",\n \"permissions\": {\n \"inherit\": true,\n \"rolePermissions\": []\n },\n \"testScenario\": {\n \"request\": {\n \"actionId\": {{actionId}},\n \"serviceId\": {{serviceId}}\n },\n \"attributeOverrides\": {},\n \"serviceOverrides\": {}\n }\n}",
};
$.ajax(settings).done(function (response) {
console.log(response);
});
var request = require('request');
var options = {
'method': 'POST',
'url': '{{apiPath}}/test-suite/{{testSuiteEntityId}}?branch={{branchId}}',
'headers': {
'x-user-id': '{{userId}}',
'Content-Type': 'application/json'
},
body: '{\n "name": "child-test-scenario",\n "description": "",\n "objectType": "TestScenarioDefinition",\n "permissions": {\n "inherit": true,\n "rolePermissions": []\n },\n "testScenario": {\n "request": {\n "actionId": {{actionId}},\n "serviceId": {{serviceId}}\n },\n "attributeOverrides": {},\n "serviceOverrides": {}\n }\n}'
};
request(options, function (error, response) {
if (error) throw new Error(error);
console.log(response.body);
});
import requests
import json
url = "{{apiPath}}/test-suite/{{testSuiteEntityId}}?branch={{branchId}}"
payload = "{\n \"name\": \"child-test-scenario\",\n \"description\": \"\",\n \"objectType\": \"TestScenarioDefinition\",\n \"permissions\": {\n \"inherit\": true,\n \"rolePermissions\": []\n },\n \"testScenario\": {\n \"request\": {\n \"actionId\": {{actionId}},\n \"serviceId\": {{serviceId}}\n },\n \"attributeOverrides\": {},\n \"serviceOverrides\": {}\n }\n}"
headers = {
'x-user-id': '{{userId}}',
'Content-Type': 'application/json'
}
response = requests.request("POST", url, headers=headers, data=payload)
print(response.text)
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/test-suite/{{testSuiteEntityId}}?branch={{branchId}}');
$request->setMethod(HTTP_Request2::METHOD_POST);
$request->setConfig(array(
'follow_redirects' => TRUE
));
$request->setHeader(array(
'x-user-id' => '{{userId}}',
'Content-Type' => 'application/json'
));
$request->setBody('{\n "name": "child-test-scenario",\n "description": "",\n "objectType": "TestScenarioDefinition",\n "permissions": {\n "inherit": true,\n "rolePermissions": []\n },\n "testScenario": {\n "request": {\n "actionId": {{actionId}},\n "serviceId": {{serviceId}}\n },\n "attributeOverrides": {},\n "serviceOverrides": {}\n }\n}');
try {
$response = $request->send();
if ($response->getStatus() == 200) {
echo $response->getBody();
}
else {
echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
$response->getReasonPhrase();
}
}
catch(HTTP_Request2_Exception $e) {
echo 'Error: ' . $e->getMessage();
}
require "uri"
require "json"
require "net/http"
url = URI("{{apiPath}}/test-suite/{{testSuiteEntityId}}?branch={{branchId}}")
http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Post.new(url)
request["x-user-id"] = "{{userId}}"
request["Content-Type"] = "application/json"
request.body = "{\n \"name\": \"child-test-scenario\",\n \"description\": \"\",\n \"objectType\": \"TestScenarioDefinition\",\n \"permissions\": {\n \"inherit\": true,\n \"rolePermissions\": []\n },\n \"testScenario\": {\n \"request\": {\n \"actionId\": {{actionId}},\n \"serviceId\": {{serviceId}}\n },\n \"attributeOverrides\": {},\n \"serviceOverrides\": {}\n }\n}"
response = http.request(request)
puts response.read_body
let parameters = "{\n \"name\": \"child-test-scenario\",\n \"description\": \"\",\n \"objectType\": \"TestScenarioDefinition\",\n \"permissions\": {\n \"inherit\": true,\n \"rolePermissions\": []\n },\n \"testScenario\": {\n \"request\": {\n \"actionId\": {{actionId}},\n \"serviceId\": {{serviceId}}\n },\n \"attributeOverrides\": {},\n \"serviceOverrides\": {}\n }\n}"
let postData = parameters.data(using: .utf8)
var request = URLRequest(url: URL(string: "{{apiPath}}/test-suite/{{testSuiteEntityId}}?branch={{branchId}}")!,timeoutInterval: Double.infinity)
request.addValue("{{userId}}", forHTTPHeaderField: "x-user-id")
request.addValue("application/json", forHTTPHeaderField: "Content-Type")
request.httpMethod = "POST"
request.httpBody = postData
let task = URLSession.shared.dataTask(with: request) { data, response, error in
guard let data = data else {
print(String(describing: error))
return
}
print(String(data: data, encoding: .utf8)!)
}
task.resume()
Example Response
201 Created
{
"objectType": "TestScenarioDefinition",
"id": "71419680-6f72-4781-9595-8ee83c0e5835",
"version": "932877d9-0000-48a1-a489-e7a6d32a967e",
"type": "TEST_SCENARIO",
"name": "child-test-scenario",
"fullName": "new group.child-test-scenario",
"description": "",
"parentId": "3e0e2026-78bc-49ec-8537-ccf4bbedc935",
"numberOfChildren": 0,
"permissions": {
"inherit": true,
"rolePermissions": []
},
"testScenario": {
"request": {
"domainId": null,
"serviceId": "25769e5c-5b33-4daf-9780-3e09b6f32207",
"identityProviderId": null,
"actionId": "b072d76e-0085-4423-99c2-4e16b74e88fa",
"attributes": {}
},
"attributeOverrides": {},
"serviceOverrides": {}
},
"properties": []
}